sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=85
left=85
caption="CSD 0.8 beta"
tileSpacing=10
End CompInit
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption="group2"
look=2
tile=1
left=154
top=9
visible=1
End CompInit
group2.name="group2"
Dim m_group as group
m_group = MakeComponent("group",form1)
CompInit m_group
proto="m_group"
caption=""
look=1
sizeHControl=3
sizeVControl=3
tile=1
tileHAlign=3
left=0
top=0
visible=1
End CompInit
Dim k_group as group
k_group = MakeComponent("group",m_group)
CompInit k_group
proto="k_group"
caption=""
look=2
tile=1
sizeHControl=0
sizeVControl=3
tileLayout=1
tileHAlign=3
width=295
visible=1
End CompInit
Dim label7 as label
label7 = MakeComponent("label",k_group)
CompInit label7
proto="label7"
caption="Kennzeichen: "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label7.name="label7"
Dim k_entry as entry
k_entry = MakeComponent("entry",k_group)
CompInit k_entry
proto="k_entry"
width=150
maxChars=3
text="pir"
visible=1
End CompInit
k_entry.name="k_entry"
Dim sk_button as button
sk_button = MakeComponent("button",k_group)
CompInit sk_button
proto="sk_button"
caption="Suche"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
sk_button.name="sk_button"
k_group.name="k_group"
Dim o_group as group
o_group = MakeComponent("group",m_group)
CompInit o_group
proto="o_group"
caption=""
look=2
sizeHControl=0
sizeVControl=3
tile=1
tileLayout=1
tileHAlign=3
width=295
visible=1
End CompInit
Dim label8 as label
label8 = MakeComponent("label",o_group)
CompInit label8
proto="label8"
caption="Ort: "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label8.name="label8"
Dim o_entry as entry
o_entry = MakeComponent("entry",o_group)
CompInit o_entry
proto="o_entry"
width=150
visible=1
End CompInit
o_entry.name="o_entry"
Dim so_button as button
so_button = MakeComponent("button",o_group)
CompInit so_button
proto="so_button"
caption="Suche"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
so_button.name="so_button"
o_group.name="o_group"
Dim l_group as group
l_group = MakeComponent("group",m_group)
CompInit l_group
proto="l_group"
caption=""
look=2
height=18
sizeHControl=0
tileLayout=1
width=295
visible=1
End CompInit
Dim label9 as label
label9 = MakeComponent("label",l_group)
CompInit label9
proto="label9"
caption="Bundesland: "
sizeHControl=3
sizeVControl=3
left=24
top=3
visible=1
End CompInit
label9.name="label9"
Dim bl_label as label
bl_label = MakeComponent("label",l_group)
CompInit bl_label
proto="bl_label"
caption="???"
sizeHControl=3
sizeVControl=3
left=100
top=3
visible=1
End CompInit
bl_label.name="bl_label"
l_group.name="l_group"
m_group.name="m_group"
Dim line_label as label
line_label = MakeComponent("label",form1)
CompInit line_label
proto="line_label"
caption="Time: 00:00"
left=125
top=74
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
line_label.name="line_label"
form1.width=317
form1.height=116
form1.name="form1"
Dim sound1 as sound
sound1 = MakeComponent("sound","app")
CompInit sound1
proto="sound1"
End CompInit
sound1.name="sound1"
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
Dim timedate1 as timedate
timedate1 = MakeComponent("timedate","app")
CompInit timedate1
proto="timedate1"
End CompInit
timedate1.name="timedate1"
Dim sound2 as sound
sound2 = MakeComponent("sound","app")
CompInit sound2
proto="sound2"
End CompInit
sound2.name="sound2"
EnableEvents()
duplo_start()
end sub

sub duplo_start()

' 07.06.98 dh

' Datei definieren / define file
dim testfile as component
testfile = MakeComponent("file","top")
testfile.name = "dtl.dat"

' FileCheck
if testfile.size = 0
	sound1.StandardSound(0)
	MessageBox("Fehler","Datei dtl.dat existiert nicht !")
	testfile.delete()
end if

' BubbleHelp
label7.helpContext = "$$$Car Sign:"
label8.helpContext = "$$$City:"
label9.helpContext = "$$$Country:"
sk_button.helpContext = "$$$Search for Car Sign"
so_button.helpContext = "$$$Search for City"

' Zwischenspeicher definieren / define data
dim csv[4] as string

' Variablen fuer Suchezeit / things for searchtime
dim starttime as long
dim stoptime as long
dim difftime as long
dim diffmin as integer
dim diffsec as integer

' damit es im Interpreter funktioniert / for interpreter test app
form1.visible = 1

dim nextline as integer

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

function GetNextLine(start as integer) as string

' Funktion um die naechste Zeile zu erhalten
' function to get the next line

' last change 31.05 - dh

dim c as integer         ' counter
dim ende as integer      ' = dateiende / end of file
dim linedummy as string  ' Zwischenspeicher fuer Zeile

ende = testfile.size ' ende auf Dateigroesse setzen

for c = start to ende
	testfile.go(c) ' go to counter

	if testfile.peek() = 13	' pruefen ob Zeilenende erreicht
		exit for				' check if CR reached
	else
		testfile.go(c)			' to read also the first charter
		linedummy = linedummy + chr(testfile.peek())
		' Zeichen an dieser Stelle auslesen und an dummy anhaengen
		' read out the charter at this place and add it to linedummy
	end if
next c

SplitCsv(linedummy,"",0)

if c+1 > testfile.size or c+1 = testfile.size
else
	nextline = c+1
end if

end function

sub SplitCsv(source as string, target as string, flag as integer)

' target = zu suchendes Kennzeichen
' flag = was suchen: Kennzeichen oder Ort
dim sstart as integer
dim c1 as integer 'counter
dim c2 as integer
sstart = 1
dim dummystring as string

for c1 = 1 to 3
	for c2 = sstart to len(source)
		dummystring = mid(source, c2, 1)
		if dummystring = ","
			csv[c1] = mid(source, 1, c2-1)
			exit for
		end if
	next c2
	if InStr(source,",") = 0
		csv[3] = source
	else
		source = right(source, len(source)-len(csv[c1])-1)
		csv[3] = source + " - Fehler: mehr als 3 Datenfelder"
	end if
next c1

end sub

sub sk_button_pressed(self as button)

busy1.Enter()   ' mark system busy
testfile.open() ' Datei oeffnen / file open
starttime = timedate1.systemClock ' set starttime

dim dummy as string
nextline = 0

do
	dummy = GetNextLine(nextline)
loop until lower(csv[1]) = lower(k_entry.text) or testfile.ends()=1

	o_entry.text     = csv[2]
	bl_label.caption = csv[3]

testfile.close() ' close the file / Datei schliessen

stoptime = timedate1.systemClock
difftime = stoptime - starttime
diffsec = difftime/1000
if diffsec > 60
	diffmin = diffsec/60
	diffsec = diffsec - int(diffmin)*60
end if

line_label.caption = "Time: "+str(diffmin)+":"+CorrectString(str(diffsec))

if testfile.ends()=1
	sound1.StandardSound(0)
	o_entry.text     = "Fehler / Error"
	k_entry.caption  = "Fehler / Error"
	bl_label.caption = "Fehler / Error"
else
	sound1.StandardSound(2)
end if

busy1.Leave()

end sub

sub so_button_pressed(self as button)

busy1.Enter()
testfile.open() ' Datei oeffnen / file open
starttime = timedate1.systemClock
dim dummy as string
nextline = 0

do
	dummy = GetNextLine(nextline)
loop until lower(csv[2]) = lower(o_entry.text) or testfile.ends()=1

	k_entry.text     = csv[1]
'	o_entry.text     = csv[2]
	bl_label.caption = csv[3]

testfile.close() ' close the file / Datei schliessen


stoptime = timedate1.systemClock
difftime = stoptime - starttime
diffsec = difftime/1000
if diffsec > 60
	diffmin = diffsec/60
	diffsec = diffsec - int(diffmin)*60
end if

line_label.caption = "Time: "+str(diffmin)+":"+CorrectString(str(diffsec))

if testfile.ends()=1
	sound1.StandardSound(0)
	o_entry.text     = "Fehler / Error"
	k_entry.caption  = "Fehler / Error"
	bl_label.caption = "Fehler / Error"
else
	sound1.StandardSound(2)
end if

busy1.Leave()

end sub

function CorrectString(stelle as string) as string

' Korrektur der Zeitanzeige: "3" -> "03"

if Len(stelle) = 1
	CorrectString = "0"+stelle
else
	CorrectString = stelle
end if

end function

function lower(input as string) as string

dim counter as integer
dim charter as string

for counter = 1 to len(input)

	charter = mid(input, counter, 1)

	if asc(charter) > 64 and asc(charter) < 91 then
		charter = chr(asc(charter)+32)
	else if charter = chr(128)
		charter = chr(138)
	else if charter = chr(133)
		charter = chr(154)
	else if charter = chr(134)
		charter = chr(159)
	end if

	lower = lower + charter

next counter

end function

sub o_entry_entered(self as entry)
	so_button_pressed(so_button)
end sub

sub k_entry_entered(self as entry)
	sk_button_pressed(sk_button)
end sub

sub MessageBox(msgb_title as string, msgb_message as string)

	dim msgb_dialog as component
	msgb_dialog = MakeComponent("dialog", "app")
	msgb_dialog.proto ="msgb_dialog"
	msgb_dialog.caption = msgb_title
	msgb_dialog.sizeHControl=3
	msgb_dialog.sizeVControl=3

	dim msgb_group as component
	msgb_group = MakeComponent("group", msgb_dialog)
	msgb_group.proto = "msgb_group"
	msgb_group.look = 0
	msgb_group.sizeHControl=3
	msgb_group.sizeVControl=3
	msgb_group.tile = 1
	msgb_group.tileSpacing = 5
	msgb_group.left = 0
	msgb_group.top = 0
	msgb_group.tileHAlign = 0

   	dim msgb_text as component
	msgb_text = MakeComponent("label", msgb_group)
	msgb_text.proto = "msgb_text"
	msgb_text.caption = msgb_message

	dim msgb_btn as component
	msgb_btn = MakeComponent("button", msgb_group)
	msgb_btn.proto = "msgb_btn"
	msgb_btn.caption = "OK"
	msgb_btn.visible = 1
	msgb_btn.default = 1
	msgb_btn.closeDialog = 1

	msgb_group.visible = 1
	msgb_text.visible = 1
	msgb_dialog.visible = 1

end sub

